package epe.agents.agentListeners.reorganization;

	import java.util.Vector;

public class ReorganizationListeners {
  
  	protected Vector<Object> vector;
  
  public ReorganizationListeners() {
    vector = new Vector<Object>();
  }
  
  public void addListener(ReorganizationListener listener) {
    vector.addElement(listener);
  }
  
  public void removeListener(ReorganizationListener listener) {
    vector.removeElement(listener);
  }
  
  public void notifyReorganizationListenersOfAddLink(String type, String source, String target) {
    for (int i=0; i<vector.size(); i++)
      ((ReorganizationListener)vector.elementAt(i)).linkAdded(type, source, target);
  }
  
  public void notifyReorganizationListenersOfRemoveLink(String type, String source, String target) {
    for (int i=0; i<vector.size(); i++)
      ((ReorganizationListener)vector.elementAt(i)).linkRemoved(type, source, target);
  }
  
}
