/*
 * OrganizationalProximityCalculator.java
 *
 * Created on 12 fvrier 2003, 11:22
 */

package epe.annexTools.systematicOrganizationsStatisticTool.organizationalProximity;

/**
 *
 * @author  george
 */
public class OrganizationalProximityCalculator {
  
  protected int[] factorialLinks = {5,4,1,3,2,4,3,8,0,6,3,7};
  
  // Instance permutations
  protected int[] factorialLinksAlt01 = {5,4,0,3,1,4,3,8,2,6,3,7};
  protected int[] factorialLinksAlt02 = {5,4,0,4,1,3,3,8,2,7,3,6};
  protected int[] factorialLinksAlt03 = {5,4,0,3,2,4,3,8,1,6,3,7};
  protected int[] factorialLinksAlt04 = {5,4,0,4,2,3,3,8,1,7,3,6};
  protected int[] factorialLinksAlt05 = {5,4,1,3,0,4,3,8,2,6,3,7};
  protected int[] factorialLinksAlt06 = {5,4,1,4,0,3,3,8,2,7,3,6};
  protected int[] factorialLinksAlt07 = {5,4,1,3,2,4,3,8,0,6,3,7};
  protected int[] factorialLinksAlt08 = {5,4,1,4,2,3,3,8,0,7,3,6};
  protected int[] factorialLinksAlt09 = {5,4,2,3,0,4,3,8,1,6,3,7};
  protected int[] factorialLinksAlt10 = {5,4,2,4,0,3,3,8,1,7,3,6};
  protected int[] factorialLinksAlt11 = {5,4,2,3,1,4,3,8,0,6,3,7};
  protected int[] factorialLinksAlt12 = {5,4,2,4,1,3,3,8,0,7,3,6};
  // AgentEquals IN1/IN2 permutations
  protected int[] factorialLinksAlt13 = {5,4,0,3,1,4,8,3,2,6,3,7};
  protected int[] factorialLinksAlt14 = {5,4,0,4,1,3,8,3,2,7,3,6};
  protected int[] factorialLinksAlt15 = {5,4,0,3,2,4,8,3,1,6,3,7};
  protected int[] factorialLinksAlt16 = {5,4,0,4,2,3,8,3,1,7,3,6};
  protected int[] factorialLinksAlt17 = {5,4,1,3,0,4,8,3,2,6,3,7};
  protected int[] factorialLinksAlt18 = {5,4,1,4,0,3,8,3,2,7,3,6};
  protected int[] factorialLinksAlt19 = {5,4,1,3,2,4,8,3,0,6,3,7};
  protected int[] factorialLinksAlt20 = {5,4,1,4,2,3,8,3,0,7,3,6};
  protected int[] factorialLinksAlt21 = {5,4,2,3,0,4,8,3,1,6,3,7};
  protected int[] factorialLinksAlt22 = {5,4,2,4,0,3,8,3,1,7,3,6};
  protected int[] factorialLinksAlt23 = {5,4,2,3,1,4,8,3,0,6,3,7};
  protected int[] factorialLinksAlt24 = {5,4,2,4,1,3,8,3,0,7,3,6};
  // AgentAddition IN1/IN2 permutations
  protected int[] factorialLinksAlt25 = {5,4,0,3,1,4,3,8,6,2,3,7};
  protected int[] factorialLinksAlt26 = {5,4,0,4,1,3,3,8,7,2,3,6};
  protected int[] factorialLinksAlt27 = {5,4,0,3,2,4,3,8,6,1,3,7};
  protected int[] factorialLinksAlt28 = {5,4,0,4,2,3,3,8,7,1,3,6};
  protected int[] factorialLinksAlt29 = {5,4,1,3,0,4,3,8,6,2,3,7};
  protected int[] factorialLinksAlt30 = {5,4,1,4,0,3,3,8,7,2,3,6};
  protected int[] factorialLinksAlt31 = {5,4,1,3,2,4,3,8,6,0,3,7};
  protected int[] factorialLinksAlt32 = {5,4,1,4,2,3,3,8,7,0,3,6};
  protected int[] factorialLinksAlt33 = {5,4,2,3,0,4,3,8,6,1,3,7};
  protected int[] factorialLinksAlt34 = {5,4,2,4,0,3,3,8,7,1,3,6};
  protected int[] factorialLinksAlt35 = {5,4,2,3,1,4,3,8,6,0,3,7};
  protected int[] factorialLinksAlt36 = {5,4,2,4,1,3,3,8,7,0,3,6};
  
  protected int[] factorialLinksAlt37 = {5,4,0,3,1,4,8,3,6,2,3,7};
  protected int[] factorialLinksAlt38 = {5,4,0,4,1,3,8,3,7,2,3,6};
  protected int[] factorialLinksAlt39 = {5,4,0,3,2,4,8,3,6,1,3,7};
  protected int[] factorialLinksAlt40 = {5,4,0,4,2,3,8,3,7,1,3,6};
  protected int[] factorialLinksAlt41 = {5,4,1,3,0,4,8,3,6,2,3,7};
  protected int[] factorialLinksAlt42 = {5,4,1,4,0,3,8,3,7,2,3,6};
  protected int[] factorialLinksAlt43 = {5,4,1,3,2,4,8,3,6,0,3,7};
  protected int[] factorialLinksAlt44 = {5,4,1,4,2,3,8,3,7,0,3,6};
  protected int[] factorialLinksAlt45 = {5,4,2,3,0,4,8,3,6,1,3,7};
  protected int[] factorialLinksAlt46 = {5,4,2,4,0,3,8,3,7,1,3,6};
  protected int[] factorialLinksAlt47 = {5,4,2,3,1,4,8,3,6,0,3,7};
  protected int[] factorialLinksAlt48 = {5,4,2,4,1,3,8,3,7,0,3,6};
  
  // AgentMultiplication IN1/IN2 permutations
  protected int[] factorialLinksAlt49 = {5,4,0,3,1,4,3,8,2,6,7,3};
  protected int[] factorialLinksAlt50 = {5,4,0,4,1,3,3,8,2,7,6,3};
  protected int[] factorialLinksAlt51 = {5,4,0,3,2,4,3,8,1,6,7,3};
  protected int[] factorialLinksAlt52 = {5,4,0,4,2,3,3,8,1,7,6,3};
  protected int[] factorialLinksAlt53 = {5,4,1,3,0,4,3,8,2,6,7,3};
  protected int[] factorialLinksAlt54 = {5,4,1,4,0,3,3,8,2,7,6,3};
  protected int[] factorialLinksAlt55 = {5,4,1,3,2,4,3,8,0,6,7,3};
  protected int[] factorialLinksAlt56 = {5,4,1,4,2,3,3,8,0,7,6,3};
  protected int[] factorialLinksAlt57 = {5,4,2,3,0,4,3,8,1,6,7,3};
  protected int[] factorialLinksAlt58 = {5,4,2,4,0,3,3,8,1,7,6,3};
  protected int[] factorialLinksAlt59 = {5,4,2,3,1,4,3,8,0,6,7,3};
  protected int[] factorialLinksAlt60 = {5,4,2,4,1,3,3,8,0,7,6,3};

  protected int[] factorialLinksAlt61 = {5,4,0,3,1,4,8,3,2,6,7,3};
  protected int[] factorialLinksAlt62 = {5,4,0,4,1,3,8,3,2,7,6,3};
  protected int[] factorialLinksAlt63 = {5,4,0,3,2,4,8,3,1,6,7,3};
  protected int[] factorialLinksAlt64 = {5,4,0,4,2,3,8,3,1,7,6,3};
  protected int[] factorialLinksAlt65 = {5,4,1,3,0,4,8,3,2,6,7,3};
  protected int[] factorialLinksAlt66 = {5,4,1,4,0,3,8,3,2,7,6,3};
  protected int[] factorialLinksAlt67 = {5,4,1,3,2,4,8,3,0,6,7,3};
  protected int[] factorialLinksAlt68 = {5,4,1,4,2,3,8,3,0,7,6,3};
  protected int[] factorialLinksAlt69 = {5,4,2,3,0,4,8,3,1,6,7,3};
  protected int[] factorialLinksAlt70 = {5,4,2,4,0,3,8,3,1,7,6,3};
  protected int[] factorialLinksAlt71 = {5,4,2,3,1,4,8,3,0,6,7,3};
  protected int[] factorialLinksAlt72 = {5,4,2,4,1,3,8,3,0,7,6,3};

  protected int[] factorialLinksAlt73 = {5,4,0,3,1,4,3,8,6,2,7,3};
  protected int[] factorialLinksAlt74 = {5,4,0,4,1,3,3,8,7,2,6,3};
  protected int[] factorialLinksAlt75 = {5,4,0,3,2,4,3,8,6,1,7,3};
  protected int[] factorialLinksAlt76 = {5,4,0,4,2,3,3,8,7,1,6,3};
  protected int[] factorialLinksAlt77 = {5,4,1,3,0,4,3,8,6,2,7,3};
  protected int[] factorialLinksAlt78 = {5,4,1,4,0,3,3,8,7,2,6,3};
  protected int[] factorialLinksAlt79 = {5,4,1,3,2,4,3,8,6,0,7,3};
  protected int[] factorialLinksAlt80 = {5,4,1,4,2,3,3,8,7,0,6,3};
  protected int[] factorialLinksAlt81 = {5,4,2,3,0,4,3,8,6,1,7,3};
  protected int[] factorialLinksAlt82 = {5,4,2,4,0,3,3,8,7,1,6,3};
  protected int[] factorialLinksAlt83 = {5,4,2,3,1,4,3,8,6,0,7,3};
  protected int[] factorialLinksAlt84 = {5,4,2,4,1,3,3,8,7,0,6,3};
  
  protected int[] factorialLinksAlt85 = {5,4,0,3,1,4,8,3,6,2,7,3};
  protected int[] factorialLinksAlt86 = {5,4,0,4,1,3,8,3,7,2,6,3};
  protected int[] factorialLinksAlt87 = {5,4,0,3,2,4,8,3,6,1,7,3};
  protected int[] factorialLinksAlt88 = {5,4,0,4,2,3,8,3,7,1,6,3};
  protected int[] factorialLinksAlt89 = {5,4,1,3,0,4,8,3,6,2,7,3};
  protected int[] factorialLinksAlt90 = {5,4,1,4,0,3,8,3,7,2,6,3};
  protected int[] factorialLinksAlt91 = {5,4,1,3,2,4,8,3,6,0,7,3};
  protected int[] factorialLinksAlt92 = {5,4,1,4,2,3,8,3,7,0,6,3};
  protected int[] factorialLinksAlt93 = {5,4,2,3,0,4,8,3,6,1,7,3};
  protected int[] factorialLinksAlt94 = {5,4,2,4,0,3,8,3,7,1,6,3};
  protected int[] factorialLinksAlt95 = {5,4,2,3,1,4,8,3,6,0,7,3};
  protected int[] factorialLinksAlt96 = {5,4,2,4,1,3,8,3,7,0,6,3};
  
  protected int[] organizationToCompare;
  
  protected int[][] allFactorialOrganizations ={factorialLinksAlt01,
                                                factorialLinksAlt02,
                                                factorialLinksAlt03,
                                                factorialLinksAlt04,
                                                factorialLinksAlt05,
                                                factorialLinksAlt06,
                                                factorialLinksAlt07,
                                                factorialLinksAlt08,
                                                factorialLinksAlt09,
                                                factorialLinksAlt10,
                                                factorialLinksAlt11,
                                                factorialLinksAlt12,
                                                factorialLinksAlt13,
                                                factorialLinksAlt14,
                                                factorialLinksAlt15,
                                                factorialLinksAlt16,
                                                factorialLinksAlt17,
                                                factorialLinksAlt18,
                                                factorialLinksAlt19,
                                                factorialLinksAlt20,
                                                factorialLinksAlt21,
                                                factorialLinksAlt22,
                                                factorialLinksAlt23,
                                                factorialLinksAlt24,
                                                factorialLinksAlt25,
                                                factorialLinksAlt26,
                                                factorialLinksAlt27,
                                                factorialLinksAlt28,
                                                factorialLinksAlt29,
                                                factorialLinksAlt30,
                                                factorialLinksAlt31,
                                                factorialLinksAlt32,
                                                factorialLinksAlt33,
                                                factorialLinksAlt34,
                                                factorialLinksAlt35,
                                                factorialLinksAlt36,
                                                factorialLinksAlt37,
                                                factorialLinksAlt38,
                                                factorialLinksAlt39,
                                                factorialLinksAlt40,
                                                factorialLinksAlt41,
                                                factorialLinksAlt42,
                                                factorialLinksAlt43,
                                                factorialLinksAlt44,
                                                factorialLinksAlt45,
                                                factorialLinksAlt46,
                                                factorialLinksAlt47,
                                                factorialLinksAlt48,
                                                factorialLinksAlt49,
                                                factorialLinksAlt50,
                                                factorialLinksAlt51,
                                                factorialLinksAlt52,
                                                factorialLinksAlt53,
                                                factorialLinksAlt54,
                                                factorialLinksAlt55,
                                                factorialLinksAlt56,
                                                factorialLinksAlt57,
                                                factorialLinksAlt58,
                                                factorialLinksAlt59,
                                                factorialLinksAlt60,
                                                factorialLinksAlt61,
                                                factorialLinksAlt62,
                                                factorialLinksAlt63,
                                                factorialLinksAlt64,
                                                factorialLinksAlt65,
                                                factorialLinksAlt66,
                                                factorialLinksAlt67,
                                                factorialLinksAlt68,
                                                factorialLinksAlt69,
                                                factorialLinksAlt70,
                                                factorialLinksAlt71,
                                                factorialLinksAlt72,
                                                factorialLinksAlt73,
                                                factorialLinksAlt74,
                                                factorialLinksAlt75,
                                                factorialLinksAlt76,
                                                factorialLinksAlt77,
                                                factorialLinksAlt78,
                                                factorialLinksAlt79,
                                                factorialLinksAlt80,
                                                factorialLinksAlt81,
                                                factorialLinksAlt82,
                                                factorialLinksAlt83,
                                                factorialLinksAlt84,
                                                factorialLinksAlt85,
                                                factorialLinksAlt86,
                                                factorialLinksAlt87,
                                                factorialLinksAlt88,
                                                factorialLinksAlt89,
                                                factorialLinksAlt90,
                                                factorialLinksAlt91,
                                                factorialLinksAlt92,
                                                factorialLinksAlt93,
                                                factorialLinksAlt94,
                                                factorialLinksAlt95,
                                                factorialLinksAlt96};

  protected int[] testLinks = {9,9,9,9,9,9,9,9,9,9,9,9};
                                                 
  /** Creates a new instance of OrganizationalProximityCalculator */
  public OrganizationalProximityCalculator() {
  }
  
  public void setOrganizationToCompare(int[] links) {
    organizationToCompare = links;
  }
  
  public int bestProximity(int[] links) {
    organizationToCompare = links;
    int maxCounter = 0;
    int counter = 0;
    for (int i = 0; i < allFactorialOrganizations.length; i++) {
      counter = compareProximity(allFactorialOrganizations[i]);
      if (counter > maxCounter)
        maxCounter = counter;
    }
    return maxCounter;
  }
  
  public int compareProximity(int[] organization) {
    int counter = 0;
    for (int i = 0; i<organization.length; i++)
      if (organization[i] == organizationToCompare[i])
        counter++;
    return counter;
  }
  
  public int[] getTestLinks() {
    return testLinks;
  }
  
  public int[] getFactLinks(int i) {
    return allFactorialOrganizations[i];
  }
  
  public static void main(String[] arg) {
    OrganizationalProximityCalculator calculator = new OrganizationalProximityCalculator();
    System.out.print("Comparing : ");
    for (int i=0; i<12; i++)
      System.out.print(calculator.getTestLinks()[i]+ " ");
    System.out.println();
    System.out.print("and :       ");
    for (int i=0; i<12; i++)
      System.out.print(calculator.getFactLinks(0)[i]+ " ");
    System.out.println();
    System.out.println();
    calculator.setOrganizationToCompare(calculator.getTestLinks());
    System.out.print("result : ");
    System.out.println(calculator.compareProximity(calculator.getFactLinks(0)));
    System.out.print("Best result : ");
    System.out.println(calculator.bestProximity(calculator.getTestLinks()));
    
  }
  
}
