/*
 * PossibleOUTs.java
 *
 * Created on 4 d?cembre 2002, 14:20
 */

package epe.annexTools.systematicOrganizationsStatisticTool.systematicOrganizationBuilder.possibleOUTs;

/**
 *
 * @author  george
 */

import java.util.Vector;
import epe.annexTools.systematicOrganizationsStatisticTool.systematicOrganizationBuilder.agentPool.AgentPool;
import epe.agents.Agent;

public class PossibleOUTs {
  
  protected Vector<Object> storage;
  protected AgentPool agentPool;
  
  /** Creates a new instance of AgentPool */
  public PossibleOUTs(AgentPool agentPool) {
    storage = new Vector<Object>();
    this.agentPool = agentPool;
    initPossibleOUTs();
  }
  
  public void initPossibleOUTs() {
    addAgent((Agent)agentPool.getAgentAt(0));  // 0 : One1
    addAgent((Agent)agentPool.getAgentAt(1));  // 1 : One2 
    addAgent((Agent)agentPool.getAgentAt(2));  // 2 : One3
    addAgent((Agent)agentPool.getAgentAt(3));  // 3 : +
    addAgent((Agent)agentPool.getAgentAt(4));  // 4 : * 
    addAgent((Agent)agentPool.getAgentAt(5));  // 5 : = 
    addAgent((Agent)agentPool.getAgentAt(6));  // 6 : F1
    addAgent((Agent)agentPool.getAgentAt(7));  // 7 : F2
    addAgent((Agent)agentPool.getAgentAt(8));  // 8 : IN
  }
  
  public void addAgent(Agent agent) {
    storage.addElement(agent);
  }
    
  public Agent getAgentAt(int index) {
    return (Agent)storage.elementAt(index);
  }

  public int getSize() {
    return storage.size();
  }
  
}
