/*
 * MessageBox.java
 *
 * Created on 10 juillet 2001, 13:47
 */

package epe.communication.messageBox;

import java.util.Vector;
import epe.communication.Message;

/**
 *
 * @author  Jean-Pierre Georg?
 * @version
 */
public class MessageBox extends Vector<Object> {
  
    private static final long serialVersionUID = 1L;

	/** Creates new MessageBox */
  public MessageBox() {
  }
  
  public void addMessage(Message message) {
    addElement(message);
  }
  
  protected void removeMessage(Message message) {
    removeElement(message);
  }
  
  public boolean isEmpty() {
   return (size() == 0);
  }
  
  public Message getMessage() {
    if (isEmpty())
      return null;
    else {
     Message message = (Message)elementAt(0);
     removeMessage(message);
     return message;
    }
  }
  
}
