package epe.communication.messages.information;

	import epe.communication.Message;
	import epe.agents.Agent;

public class CyclePingMessage extends Message {

		String direction;  // IN or OUT
		Agent testedAgent;
		Agent originAgent;
	
  public CyclePingMessage(String direction, Agent testedAgent, Agent originAgent, Agent sender) {
  	this.id = Message.CYCLE_PING_MESSAGE;
  	this.direction = direction;
  	this.testedAgent = testedAgent;
  	this.originAgent = originAgent;
    this.sender = sender;
  }
  
	public Agent getTestedAgent() {
		return testedAgent;
	}
	
	public Agent getOriginAgent() {
		return originAgent;
	}
		
	public String getDirection() {
		return direction;
	}
}