package epe.communication.messages.ncs;

import epe.communication.Message;
import epe.agents.Agent;

public class NCSNoPotentialOutputMessage extends Message {
  
  protected int effectValue;
  protected int initialEffectValue = 40;
  // Not needed : the NCS should go down all the "calculus path". Stopped by AgentOut
  protected int decreaseValue = 0;
  

  public NCSNoPotentialOutputMessage(Agent sender) {
  	this.id = Message.NCS_NO_POTENTIAL_OUTPUT_MESSAGE;
    effectValue = initialEffectValue;
    this.sender = sender;
  }

  public void decreaseEffectValue() {
  }

  public boolean isEffective() {
    return true;
  }

}