package epe.gui.animator;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import epe.agents.Agent;

/** Gere les reactions ? la souris sur l'Animator d'un agent. */
class AnimatorMouseListener implements MouseListener {

  private Agent myAgent;

  public AnimatorMouseListener(Agent thisAgent) {
    myAgent = thisAgent;
  }

  /** Invoked when the mouse has been clicked on a component. */
  public void mouseClicked(MouseEvent e) {
    //myAgent.getGUI().println( "\n\nMOUSE : Clicked\n");
    myAgent.getGUI().showAgentTextOutputPanel();
  }

  /** Invoked when the mouse enters a component. */
  public void mouseEntered(MouseEvent e) {
/*    //     my_agent.println( "\n\nMOUSE : Entered\n");
    Enumeration acqs_list = my_agent.getAcquaintancesManager().getAcquaintances().elements();

    gui.println( my_agent.getAgentName() + " : MOUSE : trustValues ..." );

    while (acqs_list.hasMoreElements()) {
      Acquaintance this_acq = (Acquaintance)acqs_list.nextElement();
      gui.println(  "                      "+ this_acq.getAgent().getAgentName() +"'s TrustValue : " + this_acq.getTrustValue().getValue() );
    }*/
  }

  /** Invoked when the mouse exits a component. */
  public void mouseExited(MouseEvent e) {
    //    my_agent.println( "\n\nMOUSE : Exited\n");
  }

  /** Invoked when a mouse button has been pressed on a component. */
  public void mousePressed(MouseEvent e) {
/*    //    my_agent.println( "\n\nMOUSE : Pressed\n");

    if( e.getModifiers() == MouseEvent.BUTTON3_MASK) {
      // affiche l'ensemble des BelievedCompetence
      Enumeration acqs_list = my_agent.getAcquaintancesManager().getAcquaintances().elements();
      Acquaintances all_ready_seen = new Acquaintances();

      gui.print( my_agent.getAgentName() + " : MOUSE : believed competences :" );

      while (acqs_list.hasMoreElements() ) {
        Acquaintance this_acq = (Acquaintance)acqs_list.nextElement();
        if( all_ready_seen.findAcquaintances(this_acq.getAgent() ).size() == 0 ) {
          // Si on n'a pas deja vu les competences de cet Agent, on les affiche. 
          Enumeration competences = this_acq.getBelievedCompetence().getBelievedCompetences().elements();
          gui.print( "     "+this_acq.getAgent().getAgentName()+" competences : " );

          while( competences.hasMoreElements() ) {
            Acquaintance competence = (Acquaintance)competences.nextElement();
            my_agent.print( competence.getAgentInterface().getType()
            +competence.getAgentInterface().getPosition()+":"+
            +competence.getTrustValue().getValue()+", " );
          }
          gui.print(";");
          all_ready_seen.addAcquaintance1( this_acq );
        }
      }
      gui.println(".");
    }
    else {
      Enumeration acqs_list = my_agent.getAcquaintancesManager().getAcquaintances().elements();
      gui.print( my_agent.getAgentName() + " : MOUSE : Acquaintances : ");

      while (acqs_list.hasMoreElements() ) {
        Acquaintance this_acq = (Acquaintance)acqs_list.nextElement();
        gui.print( this_acq.getAgent().getAgentName() +"-" + this_acq.getAgentInterface().getType()+ this_acq.getAgentInterface().getPosition()+", " );
      }
      gui.println( " ." );
    }
*/
  }

  /** Invoked when a mouse button has been released on a component. */
  public void mouseReleased(MouseEvent e) {
    //    my_agent.println( "\n\nMOUSE : Released\n");
  }


}