package epe.gui.soundPlayers;

	import java.applet.Applet;
	import java.applet.AudioClip;
	import java.net.URL;

import epe.gui.SystemPrinter;

public class ErrorSoundPlayer {
	  private Object lock = new Object();
	  private Object lock2 = new Object();
	  URL url;
	  protected String relativePath = "/data/GUI/sounds/error.wav";
	  AudioClip audioClip;
  
  public ErrorSoundPlayer() {
    try {
      url = new URL("file:" + System.getProperty("user.dir") + relativePath);
    } catch (java.net.MalformedURLException e) {
      SystemPrinter.printSystem(e.getMessage());
    }
    audioClip = Applet.newAudioClip(url);
  }
  
  public void playErrorSound() {
    
    Thread executingThread;
    // Inner threaded class so the sound plays in the background
    class SoundPlayer implements Runnable {
      AudioClip audioClip;
      public SoundPlayer(AudioClip audioClip) {
        this.audioClip = audioClip;
      }
      public void run() {
        synchronized(lock2) {
          audioClip.play();
        }
      }
    }
        
    synchronized(lock) {
      executingThread = new Thread(new SoundPlayer(audioClip));
      executingThread.start();
    }
  }
  
}
