package epe.gui.textOutput;

	import epe.gui.SystemPrinter;

public class TextOutputDeleter implements Runnable {
  
  	private AgentTextOutputPanel owner;
  
  public TextOutputDeleter(AgentTextOutputPanel owner) {
    this.owner = owner;
  }
  
  public void run() {
    synchronized(owner.lock) {
      try {
        owner.doc.remove(owner.doc.getStartPosition().getOffset(), owner.deleteSize);
      } catch (javax.swing.text.BadLocationException ble) {
        SystemPrinter.printSystem("Couldn't remove text.");
      }
      //currentHistorySize = currentHistorySize - deleteSize;
    }
  }
}
