package epe.reorganization.messageProcessors.ncs;

	import epe.gui.GUI;
	import epe.communication.Message;
	import epe.reorganization.ReorganizationMessageProcessor;

public class NCSMissingDataMessageProcessor {
  
	  protected ReorganizationMessageProcessor owner;
	  protected GUI gui;
  
  public NCSMissingDataMessageProcessor(ReorganizationMessageProcessor owner, 
                                        GUI gui) {
    this.owner = owner;
    this.gui = gui;
  }

  public void processNCSmissingDataMessage(Message receivedMessage) {
    gui.println("Processing message missingData from ["
                + receivedMessage.getSender().getAgentName() + "]"
                , java.awt.Color.orange);
    // ###DEBUG : temp : for now, treat the missingData as an inadequate Data
    owner.processNCSinadequateDataMessage(receivedMessage);
  }
  
}
