/*
 * Waiter.java
 *
 * Created on 24 avril 2000, 15:40
 */
 
package epe.synchronization.waiters;

import epe.agents.Agent;

/** 
 *
 * @author  Jean-Pierre Georg
 * @version 
 */
public class Waiter extends Object {
  
  protected Agent agent;
  protected boolean ready;

  /** Creates new Waiter */
  public Waiter(Agent agent) {
    this.agent = agent;
    ready = false;
  }
  
  public void setReady() {
    ready = true;
  }
  
  public void setNotReady() {
    ready = false;
  }
  
  public boolean isReady() {
    return ready;
  }
  
  public Agent getAgent() {
    return agent;
  }
  
  public boolean equals(Waiter waiter) {
    return (agent.equals(waiter.getAgent()));
  }
  
}