/*
 * NCSListeners.java
 *
 * Created on 21 janvier 2002, 13:53
 */

package epe.agents.agentListeners.environmentStateChanged;

import java.util.Vector;


/**
 *
 * @author  Jean-Pierre Georg?
 * @version
 */
public class EnvironmentStateChangedListeners {
  
  protected Vector<Object> vector;
  
  /** Creates new NCSListeners */
  public EnvironmentStateChangedListeners() {
    vector = new Vector<Object>();
  }
  
  public void addListener(EnvironmentStateChangedListener listener) {
    vector.addElement(listener);
  }
  
  public void removeListener(EnvironmentStateChangedListener listener) {
    vector.removeElement(listener);
  }
  
  public void notifyListeners(int data) {
    for (int i=0; i<vector.size(); i++)
      ((EnvironmentStateChangedListener)vector.elementAt(i)).environmentReceivedData(data);
  }
  
}
