/*
 * NCSListeners.java
 *
 * Created on 21 janvier 2002, 13:53
 */

package epe.agents.agentListeners.messageSend;

import java.util.Vector;
import epe.communication.Message;


/**
 *
 * @author  Jean-Pierre Georg?
 * @version
 */
public class MessageSendListeners {
  
  protected Vector<Object> vector;
  
  /** Creates new NCSListeners */
  public MessageSendListeners() {
    vector = new Vector<Object>();
  }
  
  public void addListener(MessageSendListener listener) {
    vector.addElement(listener);
  }
  
  public void removeListener(MessageSendListener listener) {
    vector.removeElement(listener);
  }
  
  public void notifyListeners() {
    for (int i=0; i<vector.size(); i++)
      ((MessageSendListener)vector.elementAt(i)).messageSend();
  }
  
  public void notifyListeners(Message message) {
    for (int i=0; i<vector.size(); i++)
      ((MessageSendListener)vector.elementAt(i)).messageSend(message);
  }
  
}
