/*
 * NCSListeners.java
 *
 * Created on 21 janvier 2002, 13:53
 */

package epe.agents.agentListeners.ncs;

import java.util.Vector;
import epe.communication.Message;


/**
 *
 * @author  Jean-Pierre Georg?
 * @version
 */
public class NcsListeners {
  
  protected Vector<Object> vector;
  
  /** Creates new NCSListeners */
  public NcsListeners() {
    vector = new Vector<Object>();
  }
  
  public void addListener(NcsListener listener) {
    vector.addElement(listener);
  }
  
  public void removeListener(NcsListener listener) {
    vector.removeElement(listener);
  }
  
  public void notifyListeners() {
    for (int i=0; i<vector.size(); i++)
      ((NcsListener)vector.elementAt(i)).ncsCreated();
  }
  
  public void notifyListeners(Message message) {
    for (int i=0; i<vector.size(); i++)
      ((NcsListener)vector.elementAt(i)).ncsCreated(message);
  }
  
  public void notifyListeners(String type) {
    for (int i=0; i<vector.size(); i++)
      ((NcsListener)vector.elementAt(i)).ncsCreated(type);
  }
  
}
