/*
 * AgentNeedingIN.java
 *
 * Created on 4 d?cembre 2002, 14:20
 */

package epe.annexTools.systematicOrganizationsStatisticTool.systematicOrganizationBuilder.agentsNeedingIN;

/**
 *
 * @author  george
 */

import java.util.Vector;
import epe.annexTools.systematicOrganizationsStatisticTool.systematicOrganizationBuilder.agentPool.AgentPool;
import epe.agents.Agent;

public class AgentsNeedingIN {
  
  protected Vector<Object> storage;
  protected AgentPool agentPool;
    
  /** Creates a new instance of AgentPool */
  public AgentsNeedingIN(AgentPool agentPool) {
    storage = new Vector<Object>();
    this.agentPool = agentPool;
    initAgentsNeedingIN();
  }
  
  public void initAgentsNeedingIN() {
    addAgent((Agent)agentPool.getAgentAt(9), 2);  // 0 : OUT IN2
    addAgent((Agent)agentPool.getAgentAt(9), 1);  // 1 : OUT IN1
    addAgent((Agent)agentPool.getAgentAt(6), 1);  // 2 : F1 IN1
    addAgent((Agent)agentPool.getAgentAt(6), 2);  // 3 : F1 IN2
    addAgent((Agent)agentPool.getAgentAt(7), 1);  // 4 : F2 IN1
    addAgent((Agent)agentPool.getAgentAt(7), 2);  // 5 : F2 IN2
    addAgent((Agent)agentPool.getAgentAt(5), 1);  // 6 : = IN1
    addAgent((Agent)agentPool.getAgentAt(5), 2);  // 7 : = IN2
    addAgent((Agent)agentPool.getAgentAt(3), 1);  // 8 : + IN1
    addAgent((Agent)agentPool.getAgentAt(3), 2);  // 9 : + IN2
    addAgent((Agent)agentPool.getAgentAt(4), 1);  // 10 : * IN1
    addAgent((Agent)agentPool.getAgentAt(4), 2);  // 11 : * IN2
    
  }
  
  public void addAgent(Agent agent, int pos) {
    storage.addElement(new AgentNeedingIN(agent, pos));
  }
    
  public Agent getAgentAt(int index) {
    return ((AgentNeedingIN)storage.elementAt(index)).getAgent();
  }

  public int getAgentPositionAt(int index) {
    return ((AgentNeedingIN)storage.elementAt(index)).getInPosition();
  }
  
  public int getSize() {
    return storage.size();
  }
  
}
