package epe.communication.messages.data;

import epe.communication.Message;
import epe.agents.Agent;

public class BooleanMessage extends Message {

  protected boolean truthValue;
  

  public BooleanMessage(boolean truthValue, Agent sender) {
  	this.id = Message.BOOLEAN_MESSAGE;
    this.truthValue = truthValue;
    this.sender = sender;
    //SystemPrinter.printSystem("NumberMessageContent created");
  }
  
  public boolean getTruthValue() {
    return truthValue;
  }
  
}