package epe.communication.messages.information;

	import epe.communication.Message;
	import epe.agents.Agent;

public class GoalReachedMessage extends Message {

		protected boolean goalReachedTruthValue;
		protected Agent origin;
	
  public GoalReachedMessage(Agent sender, boolean truthValue, Agent origin) {
  	this.id = Message.GOAL_REACHED_MESSAGE;
    this.sender = sender;
    goalReachedTruthValue = truthValue;
    this.origin = origin;
  }
  
  public boolean getGoalReachedTruthValue() {
  	return goalReachedTruthValue;
  }
  
	public Agent getOrigin() {
		return origin;
	}
}