package epe.communication.messages.information;

import epe.communication.Message;
import epe.agents.Agent;

public class PotentialOutputMessage extends Message {

  protected int potentialValue;
  

  public PotentialOutputMessage(int potentialValue, Agent sender) {
  	this.id = Message.POTENTIAL_OUTPUT_MESSAGE;
    this.potentialValue = potentialValue;
    this.sender = sender;
  }
  
  public int getPotentialValue() {
    return potentialValue;
  }
  
}