package epe.communication.messages.ncs;

import epe.communication.Message;
import epe.agents.Agent;

public class NCSMissingDataMessage extends Message {
  
  protected int effectValue;
  protected int initialEffectValue = 40;
  protected int decreaseValue = 10;
  

  public NCSMissingDataMessage(Agent sender) {
  	this.id = Message.NCS_MISSING_DATA_MESSAGE;
    effectValue = initialEffectValue;
    this.sender = sender;
  }

  public void decreaseEffectValue() {
    effectValue = effectValue - decreaseValue;
  }

  public boolean isEffective() {
    return (effectValue > 0);
  }

}