/*
 * AdequacySoundPlayer.java
 *
 * Created on 25 juillet 2002, 18:06
 */

package epe.gui;

import java.applet.Applet;
import java.applet.AudioClip;
import java.net.URL;

/**
 *
 * @author  george
 */
public class AdequacySoundPlayer {
  private Object lock = new Object();
  private Object lock2 = new Object();
  URL url;
  protected String relativePath = "/data/gui/sounds/adequacy.wav";
  AudioClip audioClip;
  
  /** Creates a new instance of TestSound */
  public AdequacySoundPlayer() {
    try {
            url = new URL("file:" + System.getProperty("user.dir") + relativePath);
          } catch (java.net.MalformedURLException e) {
            SystemPrinter.printSystem(e.getMessage());
          }
          audioClip = Applet.newAudioClip(url);
  }
  
  public void playAdequacySound() {
    Thread executingThread;
    // Inner threaded class so the sound plays in the background
    class SoundPlayer implements Runnable {
      AudioClip audioClip;
      public SoundPlayer(AudioClip audioClip) {
        this.audioClip = audioClip;
      }
      public void run() {
        synchronized(lock2) {
          audioClip.play();
        }
      }
    }
        
    synchronized(lock) {
      executingThread = new Thread(new SoundPlayer(audioClip));
      executingThread.start();
    }
  }
  
}
