/*
 * LastInOutAcquaintance.java
 *
 * Created on 13 march 2002, 14:25
 */

package epe.reorganization.potentialInOutAcquaintances.lastInOutAcquaintances;

import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

/**
 *
 * @author  Jean-Pierre Georg
 * @version 
 */
public class LastInOutAcquaintance extends Object {
  
  private Agent agent;
  private AgentInterface interfaceType;
  private int numberOfRejects = 0;

    /** Creates new LastInOutAcquaintance */
    public LastInOutAcquaintance(Agent agent, AgentInterface interfaceType) {
      this.agent = agent;
      this.interfaceType = interfaceType;
    }

    public Agent getAgent() {
      return agent; 
    }
    
    public AgentInterface getInterface() {
      return interfaceType;
    }
    
    public String getInterfaceType() {
      return interfaceType.getType();
    }
    
    public String getDataType() {
      return interfaceType.getDataType();
    }
    
    public int getNumberOfRejects() {
      return numberOfRejects;
    }
    
    public boolean setDataType(String dataType) {
      return (interfaceType.setDataType(dataType));
    }
    
    public void increaseNumberOfRejects() {
      numberOfRejects++;
    }
 
    public void resetNumberOfRejects() {
      numberOfRejects = 0;
    }
    
    public boolean equals(LastInOutAcquaintance acq) {
      return ((acq.getAgent().equals(agent))
             &(acq.getInterface().equals(interfaceType)));
    }
    
}