package epe.reorganization.thresholdAcquaintances;

	import epe.agents.Agent;
	import epe.agents.agentInterface.AgentInterface;

public class ThresholdAcquaintance extends Object {
  
	  protected Agent agent;
	  protected AgentInterface interfaceType;
	  
	public ThresholdAcquaintance(Agent agent, AgentInterface interfaceType) {
	  this.agent = agent;
	  this.interfaceType = interfaceType;
	}
	
	public Agent getAgent() {
	  return agent; 
	}
	
	public AgentInterface getInterface() {
	  return interfaceType;
	}
	
	public String getInterfaceType() {
	  return interfaceType.getType();
	}
	
	public String getDataType() {
	  return interfaceType.getDataType();
	}
	
	public boolean equals(ThresholdAcquaintance acq) {
	  return ((acq.getAgent().equals(agent))
	         &&(acq.getInterface().equals(interfaceType)));
	}

}